.nolist
include \masm32\include\masm32rt.inc

CodeAlign MACRO ct		; OPT_Assembler ml
LOCAL nops, diff
  IFNDEF Current_ORG
	Current_ORG:	; save origin by creating a label
	ORG 0		; set origin to zero
	Lbl0:
	ORG Current_ORG	; restore origin
  ENDIF
  diff_S = $-start
  diff_L = $-Lbl0
  nops_L = ct-(($-Lbl0) mod ct)	; we take Lbl0 as reference
  nops_S = ct-($-start) mod ct		; we take start as reference
  nops = nops_L
  if nops ne ct
	REPEAT nops
		nop					; for testing, we just insert nops
	ENDM
  endif
  tmp$ CATSTR <Nops_S=>, %nops_S, <, diff_S=>, %diff_S	; watch in output window
  % echo tmp$
  tmp$ CATSTR <Nops_L=>, %nops_L, <, diff_L=>, %diff_L
  % echo tmp$
ENDM

.code
start:	inc eax
	CodeAlign 8
;	nop		; use for testing
	mov eax, $	; same as THIS NEAR
	and eax, 7
	print str$(eax), ": should be zero", 13, 10
	mov eax, THIS NEAR	; loads lblThisNear
	mov edx, $		; loads EIP
	sub edx, 5		; account for mov edx, $
	.if eax!=edx
		print "$ and THIS NEAR are different in JWasm", 13, 10	; they are identical for ml, but not for JWasm
	.endif
	REPEAT 6
		dec eax	; markers for recognising the align point in Olly
	ENDM
	mov eax, THIS NEAR	; JWasm: $ loads EIP, but THIS NEAR loads lblThisNear below
;0040105A    |. B8 60104000        mov eax, 00401060
	; exactly ONE nop expected here
	gdiff = $-start
	tmp$ CATSTR <Main code:  diff=>, %gdiff
	% echo tmp$
	CodeAlign 8		; diff 124, should be only 86
lblThisNear:	mov eax, THIS NEAR	; 00401060
;00401060    |. B8 60104000        mov eax, 00401060

	and eax, 7
	inkey str$(eax), ": should be zero", 13, 10
	exit
	;int 3
	;.err	; uncomment to test the macro
end start

RichMasm options:
OxPT_DebugL	/MERGE:.data=.rdata /MERGE:.rdata=.text	; linker options for ultra short executables
OPT_WAIT	0	; wait until a key is pressed before closing the DOS box
OxPT_DelLst	0
OxPT_Assembler	ml
OPT_Tmp2Asm	1
OPT_ErrLine	0

8BFF	mov edi, edi		; 2-byte nop
8D4900	lea ecx, [ecx+00]		; 3-byte nop
8D642400	lea esp, [esp+00]		; 4-byte nop
0500000000	add eax, 00000000		; 5-byte nop (may alter flags)
8D9B00000000	lea ebx, [ebx+00000000]	; 6-byte nop
8DA42400000000	lea esp, [esp+00000000]	; 7-byte nop

OxPT_DebugA	/Zi	; activate symbols
OxPT_Assembler	mlv615	; must be present in \bin
OxPT_DebugL	/debug /debugtype:cv	; for debugging
OxPT_Linker	linkv614	; must be present in \bin
